lev.gui

## Class LHelpComponent

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - lev.gui.LComponent
      - - lev.gui.LHelpComponent

- All Implemented Interfaces:
    java.awt.image.ImageObserver, java.awt.MenuContainer, java.io.Serializable
  Direct Known Subclasses:
    LButton, LList, LMenuItem, LUserSetting

      public abstract class LHelpComponent
      extends LComponent

  A GUI component that updates a help panel with text.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `class` | `LHelpComponent.HelpActionHandler`
    `class` | `LHelpComponent.HelpFocusHandler`
    `class` | `LHelpComponent.HelpMouseHandler`

    - ### Nested classes/interfaces inherited from class java.awt.Container

      `java.awt.Container.AccessibleAWTContainer`

    - ### Nested classes/interfaces inherited from class java.awt.Component

      `java.awt.Component.AccessibleAWTComponent, java.awt.Component.BaselineResizeBehavior, java.awt.Component.BltBufferStrategy, java.awt.Component.FlipBufferStrategy`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected boolean` | `followPos`
    `protected LHelpPanel` | `help` The target help panel.
    `protected java.lang.String` | `helpPrefix`
    `protected int` | `helpYoffset` Amount to vertically offset the help text.
    `protected LSaveFile` | `save`
    `protected java.lang.Enum` | `saveTie`
    `protected java.lang.String` | `title` The title to put at the top of the help panel.

    - ### Fields inherited from class java.awt.Component

      `BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

    - ### Fields inherited from interface java.awt.image.ImageObserver

      `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `LHelpComponent(java.lang.String title)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected abstract void` | `addHelpHandler(boolean hoverListener)` Adds a help handler to each GUI component that should trigger the help panel to update.
    `void` | `addHelpPrefix(java.lang.String input)` Adds a prefix to the title.
    `java.lang.String` | `getHelp()`
    `boolean` | `hasHelp()`
    `boolean` | `isFollowingPosition()`
    `void` | `linkTo(java.lang.Enum setting, LSaveFile save, LHelpPanel help_, boolean hoverListener)` Sets the target help panel, and sets the help info to the setting's helpInfo in the savefile.
    `void` | `setFollowPosition(boolean on)` Sets whether the helpPanel should vertically align with this component when updating.
    `void` | `updateHelp()` Updates the target help panel with this component's help info.

    - ### Methods inherited from class lev.gui.LComponent

      `Add, centerIn, centerOn, centerOn, getBottom, getCenter, getRight, putUnder`

    - ### Methods inherited from class java.awt.Container

      `add, add, add, add, add, addContainerListener, addImpl, addNotify, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getAlignmentX, getAlignmentY, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getInsets, getLayout, getListeners, getMaximumSize, getMinimumSize, getMousePosition, getPreferredSize, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, isValidateRoot, layout, list, list, locate, minimumSize, paint, paintComponents, paramString, preferredSize, print, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, removeNotify, setComponentZOrder, setFocusCycleRoot, setFocusTraversalKeys, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setFont, setLayout, transferFocusDownCycle, update, validate, validateTree`

    - ### Methods inherited from class java.awt.Component

      `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, contains, createImage, createImage, createVolatileImage, createVolatileImage, disable, disableEvents, dispatchEvent, enable, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getAccessibleContext, getBackground, getBaseline, getBaselineResizeBehavior, getBounds, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getFontMetrics, getForeground, getGraphics, getGraphicsConfiguration, getHeight, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getSize, getToolkit, getTreeLock, getWidth, getX, getY, gotFocus, handleEvent, hasFocus, hide, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isDoubleBuffered, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isOpaque, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, printAll, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processKeyEvent, processMouseEvent, processMouseMotionEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, repaint, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, reshape, resize, resize, revalidate, setBackground, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setEnabled, setFocusable, setFocusTraversalKeysEnabled, setForeground, setIgnoreRepaint, setLocale, setLocation, setLocation, setMaximumSize, setMinimumSize, setName, setPreferredSize, setSize, setSize, setVisible, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### help

          protected LHelpPanel help

      The target help panel.

    - #### helpPrefix

          protected java.lang.String helpPrefix

    - #### followPos

          protected boolean followPos

    - #### saveTie

          protected java.lang.Enum saveTie

    - #### save

          protected LSaveFile save

    - #### title

          protected java.lang.String title

      The title to put at the top of the help panel.

    - #### helpYoffset

          protected int helpYoffset

      Amount to vertically offset the help text.

  - ### Constructor Detail

    - #### LHelpComponent

          public LHelpComponent(java.lang.String title)

      Parameters:
        `title` -

  - ### Method Detail

    - #### addHelpHandler

          protected abstract void addHelpHandler(boolean hoverListener)

      Adds a help handler to each GUI component that should trigger the help panel to update.
      Parameters:
        `hoverListener` -

    - #### updateHelp

          public void updateHelp()

      Updates the target help panel with this component's help info.

    - #### addHelpPrefix

          public void addHelpPrefix(java.lang.String input)

      Adds a prefix to the title.
      Parameters:
        `input` -

    - #### linkTo

          public void linkTo(java.lang.Enum setting,
                    LSaveFile save,
                    LHelpPanel help_,
                    boolean hoverListener)

      Sets the target help panel, and sets the help info to the setting's helpInfo in the savefile.
      Parameters:
        `setting` -
        `save` -
        `help_` -
        `hoverListener` -

    - #### hasHelp

          public boolean hasHelp()

      Returns:

    - #### getHelp

          public java.lang.String getHelp()

      Returns:

    - #### setFollowPosition

          public void setFollowPosition(boolean on)

      Sets whether the helpPanel should vertically align with this component when updating.
      Parameters:
        `on` -

    - #### isFollowingPosition

          public boolean isFollowingPosition()

      Returns: